;****************************************
;SINE WAVE INVERTER WITH TRICKLE CHARGER*
;          				*
; With TABLE READ and 1XCCP OUT for PWM	*
;	(With CD4081 Gated O/P)		*
;       AUTHOR: S.DAS GUPTA		*
;      K-2094,Chittaranjan Park		*
;       New Delhi-110019(INDIA)		*
;	Mob: +91-9910647733
;					*
;    Using PIC16F72 - Experiment No:4   *
;	  FILE: SIN_MODF		*
;					*
;  WITH GOLI BUZZER / LED INDICATOR	*	
;****************************************

;***************************************
; REGULATION:
; INV - MAIN C/O:
; MAIN - INV C/O:
; LO-BATT CUT:
; O.L CUT:
; O.L AUTO RESET:
; WELCOME BUZZER:
; O.L MIS-TRIP:
; L.B MIS-TRIP:
;****************************************

	LIST      P=16F72, 
            include "P16F72.inc"
	__FUSES _HS_OSC & _PWRTE_ON & _WDT_OFF & _CP_ALL

	errorlevel -301,-302

; ***** Variables Definitions *****

selfcheck macro a, bxx
	movlw bxx
	xorwf a,0
	btfsc status,z
	endm


selfcheckR macro C,D
	movf C,0
	xorwf D,0
	btfsc status,z
	endm
            
;***** RAM Ddefination ********

rambase equ 0X20

	cblock rambase
	PW		
	CHG_I		
	r_22            
	r_23            
	chg_on	
	VOLT		
	COUNT_1		
	COUNT_2		
	OL_TRIP		
	R_29		
	CHG_DUTY
	CHG		
	r_2C            
	r_2F            
	r_30            
	r_31            
	S_TEMP		
	PC_TEMP		
	TEMP		
	r_35            
	r_36            
	R_37			;FOR DELAY_1S COUNT
	R_38			;FOR DELAY_1S COUNT
	r_39            
	r_3A            
	r_3B           
	r_3C            
	r_3D           
	r_3E            
	r_3F            
	r_40            
	r_41            
	r_42            
	r_43           
	r_45            
	r_46            
	r_47            
	r_48            
	r_49            
	r_4A            
	r_4B            
	r_4C            
	r_4D            
	r_4F            
	r_50            
	r_51            
	r_53            
	r_54            
	r_56            
	r_58            
	r_59            
	r_70            
	r_71            
	r_72            
	r_73            
	r_74            
	r_75            
	DUTY		
	BATT_VOLT	
	OV_LOAD		
	AC_MAIN		
	CHG_STAGE	
	CHG_DELAY	
	r222		
	r333		
	r444		
	r555		
	r666		
	R777		
	Rxxx
	PW_BIT
	PW_TIMER		

	endc

;*******DEFINATION*****************
#DEFINE INV_SW		PORTB,1
#DEFINE trickle		PORTB,2
#DEFINE MAIN_LED	PORTB,3
#DEFINE INV_LED		PORTB,4
#DEFINE LB_LED		PORTB,5
#DEFINE OL_LED		PORTB,6
#DEFINE CHG_LED		PORTB,7
#DEFINE UPS		PORTC,4
#DEFINE BUZZER		PORTC,5
#DEFINE FAN		PORTC,6
#DEFINE RELAY		PORTC,7

#DEFINE CH_1		PORTC,1
#DEFINE CH_2		PORTC,3

;********************************
;	0.0196V=1 byte		*
;********************************



	ORG     0x0000
	GOTO    MAIN_START

	ORG     0x0004

	;BTFSC	CHG,1
	;GOTO	LED_IND	
            MOVWF   R_72
            MOVF    STATUS,W
            MOVWF   R_70		;satus_temp
            MOVF    PCLATH,W		;pc_temp
            MOVWF   R_71
            CLRF    PCLATH
            BTFSC   STATUS,RP0
            GOTO    Label_0002
	    GOTO    Label_0004



Label_0002  MOVF    R_72,W
            BCF     STATUS,RP0
            MOVWF   R_72
            BSF     STATUS,RP0
            MOVF    R_70,W
            BCF     STATUS,RP0
            MOVWF   R_70
            BSF     STATUS,RP0
            MOVF    R_71,W
            BCF     STATUS,RP0
            MOVWF   R_71



Label_0004  BTFSC   R_22,5
            GOTO    Label_000B
            MOVLW   0x81
            BSF     STATUS,RP0
            MOVWF   T2CON
            BCF     STATUS,RP0
            BCF     R_22,6
            CLRF    R_48
            GOTO    Label_000C

Label_000B  BCF     STATUS,Z
	    movlw	0X0B		;added for table read
	    subwf	duty,w
            BTFSS   STATUS,Z
            GOTO    Label_000C
            BCF     STATUS,Z
            MOVF    0x48,W
            BTFSC   STATUS,Z
            BCF     R_22,6
            BTFSC   STATUS,Z
            GOTO    Label_000C
            MOVWF   R_41
            BSF     R_22,6
            BSF     STATUS,RP0
            INCF    T2CON,f
            BCF     STATUS,RP0

Label_000C  BCF     STATUS,Z
	    movlw	0X01
	    subwf	duty,w		;added for table read
            BTFSS   STATUS,Z
            GOTO    Label_000D
            BTFSS   R_43,0
            GOTO    Label_000E
            BCF     PORTC,2	;CCP1 out
            CLRF    CCP1CON
            CLRF    CCPR1L
            CLRF    CCPR1H
            MOVLW   0x0C
	    MOVWF   CCP1CON
            BCF     R_43,0
	    BCF	    PORTC,1
	    BSF     PORTC,3
            MOVF    R_45,W
            MOVWF   R_46
            BTFSC   R_43,1
            BSF     R_43,2
            BTFSS   R_43,1
            BCF     R_43,2
            BTFSC   R_22,1
            GOTO    Label_000F
            DECFSZ  R_4A,f
            BTFSS   R_43,2
            BSF     R_22,1
            BTFSS   R_43,2
            GOTO    Label_000F
            DECF    R_51,f
            ;MOVLW   0x79
	MOVLW   0x40		;64.8% DUTY
            SUBWF   R_51,W
            ;MOVLW   0x79
	MOVLW   0x40		;64.8% DUTY
            BTFSS   STATUS,C
            MOVWF   R_51
            GOTO    Label_000D

Label_000E  BCF     PORTC,2
	    CLRF    CCP1CON
            CLRF    CCPR1L
            CLRF    CCPR1H
            MOVLW   0x0C
            MOVWF   CCP1CON
	    BSF	    PORTC,1
	    BCF     PORTC,3
            BSF     R_43,0
            MOVF    0x45,W
            MOVWF   R_46
            BTFSC   R_43,1
            BSF     R_43,2
            BTFSS   R_43,1
            BCF     R_43,2
            BTFSS   R_22,1
            GOTO    Label_000D

Label_000F  BCF     STATUS,C
            RRF     R_46,f
            BCF     STATUS,C
            RRF     R_46,f
            BTFSS   R_43,2
            GOTO    Label_0010
            MOVF    R_46,W
            SUBWF   R_51,f
            ;MOVLW   0x79
	    MOVLW   0x40		;64.8% DUTY
            BTFSS   STATUS,C
            MOVWF   R_51
            MOVF    R_51,W
	    SUBLW   0x3F
            ;SUBLW   0x78
            ;MOVLW   0x79
	    MOVLW   0x40	;64.8% DUTY ??????????
            BTFSC   STATUS,C
            MOVWF   0x51
            GOTO    Label_000D

Label_0010  MOVF    R_46,W
            ADDWF   R_51,f
            BTFSC   STATUS,C
            GOTO    Label_0011
            MOVLW   0xFF
            SUBWF   R_51,W
            BTFSS   STATUS    , C
            GOTO    Label_000D
            MOVLW   0xFE
            MOVWF   R_51

Label_000D  CLRF    R_53
	    movlw	0X07
	    movwf	pclath
	    call	table1
            MOVWF   R_3A
            BCF     STATUS,C
            RRF     R_3A,f
            BCF     STATUS,C
            RRF     R_3A,W
            MOVWF   R_3B
            BCF     STATUS,C
            RRF     R_3B,W
            MOVWF   R_3C
            BCF     STATUS,C
            RRF     R_3C,W
            MOVWF   R_3D
            BCF     STATUS,C
            RRF     R_3D,W
            MOVWF   R_3E
            BCF     STATUS,C
            RRF     R_3E,W
            MOVWF   R_3F
            BCF     STATUS,C
            RRF     R_3F,W
            MOVWF   R_40
            COMF    R_51,W
            MOVWF   R_58
            DECF    R_58,f
	;movlw	0X60		;?????????????????
            MOVLW   0x80
            SUBWF   R_58,W
            BTFSC   STATUS,C
            GOTO    Label_0012

Label_001A  MOVLW   0x40
            SUBWF   R_58,W
            BTFSC   STATUS,C
            GOTO    Label_0013

Label_001B  MOVLW   0x20
            SUBWF   R_58,W
            BTFSC   STATUS,C
            GOTO    Label_0014

Label_001C  MOVLW   0x10
            SUBWF   R_58,W
            BTFSC   STATUS,C
            GOTO    Label_0015

Label_001D  MOVLW   0x08
            SUBWF   R_58,W
            BTFSC   STATUS,C
            GOTO    Label_0016

Label_001E  MOVLW   0x04
            SUBWF   R_58,W
            BTFSC   STATUS,C
            GOTO    Label_0017

Label_001F  MOVLW   0x02
            SUBWF   R_58,W
            BTFSC   STATUS,C
            GOTO    Label_0018
            GOTO    Label_0019

Label_0012  MOVF    R_3A,W
            ADDWF   R_53,f
            BTFSC   STATUS,C
            GOTO    Label_0011
            MOVLW   0x80
            SUBWF   R_58      , f
            GOTO    Label_001A

Label_0013  MOVF    R_3B,W
            ADDWF   R_53,f
            BTFSC   STATUS,C
            GOTO    Label_0011
            MOVLW   0x40
            SUBWF   R_58,f
            GOTO    Label_001B

Label_0014  MOVF    R_3C,W
            ADDWF   R_53,f
            BTFSC   STATUS    , C
            GOTO    Label_0011
            MOVLW   0x20
            SUBWF   R_58,f
            GOTO    Label_001C

Label_0015  MOVF    R_3D,W
            ADDWF   R_53,f
            BTFSC   STATUS,C
            GOTO    Label_0011
            MOVLW   0x10
            SUBWF   R_58,f
            GOTO    Label_001D
Label_0016  MOVF    R_3E,W
            ADDWF   R_53,f
            BTFSC   STATUS,C
            GOTO    Label_0011
            MOVLW   0x08
            SUBWF   R_58,f
            GOTO    Label_001E

Label_0017  MOVF    R_3F,W
            ADDWF   R_53,f
            BTFSC   STATUS,C
            GOTO    Label_0011
            MOVLW   0x04
            SUBWF   R_58,f
            GOTO    Label_001F
Label_0018  MOVF    R_40,W
            ADDWF   R_53,f
            BTFSC   STATUS,C
            GOTO    Label_0011

Label_0019  BTFSC   R_43,0
            GOTO    Label_0020
            BCF     PORTC,2	;CCP1 out
            CLRF    CCPR1L
            MOVF    R_53,W
	    MOVWF   CCPR1L
            GOTO    Label_0021

Label_0020  BCF     PORTC,2
	    CLRF    CCPR1L
            MOVF    R_53,W
            MOVWF   CCPR1L

Label_0021  movf	duty,w
            BCF     STATUS,Z
	    sublw	0X4D
            BTFSS   STATUS,Z
            GOTO    Label_0022
	    movlw	0X00
	    movwf	duty		;added for table read

Label_0022  incf	duty,f		;added for table read
            BCF     STATUS,Z
	    movf	duty,w
	    sublw	0X29
            BTFSS   STATUS,Z
            GOTO    Label_0023
            BTFSS   R_43,0
            GOTO    Label_0023
PWM_REG     MOVLW   b'10001001'		;RA1 for OUTPUT REGULATION
            MOVWF   ADCON0
            MOVLW   0x1A
            MOVWF   R_42
LOOP_11     DECFSZ  R_42,f
            GOTO    LOOP_11
            BSF     ADCON0,GO
Label_0025  BSF     R_22,7
            BTFSC   ADCON0,GO
            GOTO    Label_0025
            MOVF    ADRES,W
            SUBWF   R_23,W
            BTFSC   STATUS,C
            BSF     R_43,01
            BTFSS   STATUS,C
            BCF     R_43,01
            MOVWF   R_45
            BTFSS   R_43,01
            GOTO    Label_0026
            BTFSS   R_22,01
            GOTO    Label_0027
            SUBWF   R_47,W
            BTFSS   STATUS,C
            DECFSZ  R_2F,f
            GOTO    Label_0027
            ;GOTO    Label_0028		;FOR SHT-CKT TRIP(close for no trip)

Label_0026  MOVLW   0x02
            MOVWF   R_2F
            COMF    R_45,f
            INCF    R_45,f
            GOTO    Label_0027		;end_int_2

Label_0023  BCF     PIR1,1		;no TMR2 to PR2 match	
            BTFSS   R_22,6
            GOTO    Label_0006
            DECFSZ  R_41,f
            GOTO    Label_0006
            BSF     STATUS,RP0		;SELECT BANK1
            DECF    T2CON,f		; not known
            BCF     STATUS,RP0		;SELECT BANK0
            BCF     R_22,6
Label_0027  BCF     PIR1,1		;;no TMR2 to PR2 match	
Label_0006  BCF     STATUS,RP0
            BCF     STATUS,RP1
            MOVF    R_70,W
            MOVWF   STATUS
            MOVF    R_71,W
            MOVWF   PCLATH
            MOVF    R_72,W
            RETFIE

MAIN_START: 
	     BSF     STATUS,RP0		;SELECT BANK1
            MOVLW   b'00000011'		;RB0/RB1:i/p, RB2 - RB7:o/p
            MOVWF   TRISB
            MOVLW   b'11111111'		;RA0 - RA5 are O/P
            MOVWF   TRISA
	    MOVLW   b'00010000'	
            MOVWF    TRISC		; all portc are output,RC4 IS I/P
            MOVLW   b'00000010'
            MOVWF   ADCON1
            BCF     STATUS ,RP0		;select bank0 
		BCF	BUZZER		;PORTC,5
		BCF	FAN		;PORTC,6
		BCF	RELAY		;PORTC,7
		BCF	MAIN_LED	;PORTB,3
		BCF	INV_LED		;PORTB,4
		BCF	LB_LED		;PORTB,5
		BCF	OL_LED		;PORTB,6
		BCF	CHG_LED		;PORTB,7
		CLRF	OL_TRIP
		CLRF	CHG_STAGE

;***WELCOME GOLI BUZZER **************
	BSF	MAIN_LED	;PORTB,3
	BSF	INV_LED		;PORTB,4
	BSF	LB_LED		;PORTB,5
	BSF	OL_LED		;PORTB,6
	BSF	CHG_LED		;PORTB,7
	BSF	BUZZER		;PORTC,5

	MOVLW	0Xff
	MOVWF	R444
	MOVLW	0X15
	MOVWF	R222
G2_BUZZER:
	MOVLW	0XFF
	MOVWF	R333
P11:	DECFSZ	R333,1
	GOTO	P11
	DECFSZ	R444,1
	GOTO	G2_BUZZER
	MOVLW	0Xff
	MOVWF	R444
	DECFSZ	R222,1
	GOTO	G2_BUZZER	

	BCF	MAIN_LED	;PORTB,3
	BCF	INV_LED		;PORTB,4
	BCF	LB_LED		;PORTB,5
	BCF	OL_LED		;PORTB,6
	BCF	CHG_LED		;PORTB,7
	BCF	BUZZER		;PORTC,5

	

	
MAIN_LOOP:
	BCF	CH_1
	BCF	CH_2

	CLRF    R_42
            CLRF    PORTB
            CLRF    PORTA
            CLRF    R_70
            CLRF    R_72
            CLRF    R_3A
            CLRF    R_3B
            CLRF    R_3C
            CLRF    R_3D
            CLRF    R_3E
            CLRF    R_3F
            CLRF    R_40

            
	    MOVLW   0x81	;d129'
            MOVWF   R_23
            MOVLW   0x32
            MOVWF   R_47
            
            BCF     R_22,5
            BCF     R_22,1
            BCF     R_22,4

            CLRF    R_43
	
            BCF     STATUS, RP0		;select bank0
            CLRF    CCPR1L
            CLRF    R_45
            CLRF    R_46
            MOVLW   0xFF
            MOVWF   R_4A
     	    MOVLW   0x02
            MOVWF   R_2F
	    BCF		PORTC,0
	BCF	PORTC,1
	BCF	PORTC,2
	BCF	PORTC,3
	BCF	BUZZER		;PORTC,5
	BCF	FAN		;PORTC,6
	BCF	RELAY		;PORTC,7

	BCF	MAIN_LED	;PORTB,3
	BCF	INV_LED		;PORTB,4
	BCF	LB_LED		;PORTB,5
	BCF	OL_LED		;PORTB,6
	BCF	CHG_LED		;PORTB,7
	bcf	trickle    

;********* End of main start initiallization *****************

PORT_CHECK: 	
		BTFSS	INV_SW		;PORTB,1
		GOTO	INVERTER_ON
		GOTO	MAIN_ON_CHECK_STD_BY            
INVERTER_ON:
		CLRF	CHG_STAGE
		BTFSC	UPS		;PORTC,4
	    	GOTO	INSTANT_START
		GOTO	DELAY_START
DELAY_START:
	    MOVLW   0xFE	;0XFE for delay/0X79 for instant PWM
            MOVWF   R_51
	    GOTO    INV_ON

INSTANT_START:
	    ;MOVLW   0x40
	    MOVLW   0x79	;0XFE for delay/0X79 for instant PWM
            MOVWF   R_51
	    GOTO    INV_ON
		
inverter_on_2:			;switching on inverter during main c/o
	CLRF	OL_TRIP		;OL AUTO RESET REGISTER
	CLRF	R_29		;REGISTER STORING NO OF OL AUTO RESET TIMES			
	    ;MOVLW   0x40
	    MOVLW   0x79	;0XFE for delay/0X79 for instant PWM
            MOVWF   R_51
	    GOTO    INV_ON

INVERTER_ON_3:
	BCF	OL_LED
	    ;MOVLW   0x40
	MOVLW   0x79
            MOVWF   R_51
	    GOTO    INV_ON
			
INV_ON:	   	
		BCF	CH_1
		BCF	CH_2		

		movlw	0X02
		movwf	duty
	 	bcf	trickle
	    	BSF	INV_LED		;PORTB,4		
		BSF	FAN		;PORTC,6 FAN ON
		BSF	RELAY		;PORTC,7 RELAY ON
		BCF	LB_LED		;PORTB,5		
		BCF	OL_LED		;PORTB,6
		BCF	MAIN_LED
		BCF	CHG_LED		
	   
            
	    	BSF     STATUS,RP0		;select bank1
            	MOVLW   b'10000001'		;prescaler 4,TMR2 is off(bit-2)
            	MOVWF   T2CON			;T2CON
            	BSF     PIR1, 01		;TMR2 to PR2 match occurred
            	BCF     STATUS, RP0
            	BCF     STATUS, RP1
            	MOVLW   b'00001100'
            	MOVWF   ccp1con			;pwm mode,
            	MOVLW   b'00110001'		;enable TMR1,int-clk,sync ext clk i/p
	    	MOVWF   T1CON		;osc is shut,1:8 prescale
      		
            	CLRF    TMR2
            	BCF     PIR1,1		;TMR2 to PR2 match NOT occurred
            	BSF     T2CON,0		;prescaler 1:4
            	BSF     T2CON,2		;timer2 is ON
            	BSF     INTCON,6		;enable all unmasked peripheral INT
            	BCF     INTCON,INTE		;disable RB0 INT
            	BSF     INTCON,GIE		;enable all unmasked INT

		BSF     PORTC, 01		;CH-1 ON
            	BCF     PORTC, 02		;PWM OFF
            	BSF     R_43 , 00
	    	BSF     PORTC, 00		;High/Lo LOGIC
	    	BCF     PORTC, 03		;CH-2 OFF
            	BSF     R_43 , 02

LP_3	BTFSC	LB_LED
	GOTO	LP_333
	BTFSC	OL_LED
	GOTO	LP_333	
LO_BATT_CHECK:
	CALL	BATT_READ
	MOVWF	BATT_VOLT
	MOVF	BATT_VOLT,W
	BCF	STATUS,C
	SUBLW	d'128'		;2.5V at pin
	BTFSC	STATUS,C
	GOTO	LO_BATT_TRIP	;<2.5V

OVER_LOAD_CHECK:
	CALL	OVER_LOAD_READ
	MOVF	ADRES,W	
	MOVWF	OV_LOAD
	MOVF	OV_LOAD,W
	BCF	STATUS,C
	SUBLW	d'128'		;VOLT SELECTED 2.5V
	BTFSS	STATUS,C	
	GOTO	OVER_LOAD_TRIP	;>2.5V


LP_333:	CALL	DELAY5MSL
	BTFSS	INV_SW		;PORTB,1
	GOTO	MAIN_ON_CHECK_INV	;close for main_check bypass
	GOTO	INVERTER_OFF
	
INVERTER_OFF:
	BCF	INV_LED		;PORTB,4
	CLRF	OL_TRIP
	CLRF	R_29
	CALL	INV_TRIP
	CALL	CLEAR_LEDS
	goto	port_check			
	
INV_TRIP:	
	clrf	intcon
	BCF	STATUS,RP0
	CLRF	CCPR1L
	CLRF	CCP1CON
	BCF	FAN		
	BCF	PORTC,0		;H-L LOGIC LOWW
	BCF	PORTC,1		;CH-1 LO
	BCF	PORTC,2		;PWM LO
	BCF	PORTC,3		;CH-2 LO
	CALL	DELAY5MSL

	    CLRF    R_42
            CLRF    R_70
            CLRF    R_72
            CLRF    R_3A
            CLRF    R_3B
            CLRF    R_3C
            CLRF    R_3D
            CLRF    R_3E
            CLRF    R_3F
            CLRF    R_40

            
	    MOVLW   0x81	;d129'
            MOVWF   R_23
            MOVLW   0x32
            MOVWF   R_47
            
            BCF     R_22,5
            BCF     R_22,1
            BCF     R_22,4

            CLRF    R_43
	
            BCF     STATUS, RP0		;select bank0
            CLRF    CCPR1L
            CLRF    R_45
            CLRF    R_46
            MOVLW   0xFF
            MOVWF   R_4A
     	    MOVLW   0x02
            MOVWF   R_2F
	RETURN

CLEAR_LEDS:
	CLRF	OL_TRIP
	BCF	BUZZER		;PORTC,5
	BCF	FAN		;PORTC,6
	BCF	RELAY		;PORTC,7

	BCF	MAIN_LED	;PORTB,3
	BCF	INV_LED		;PORTB,4
	BCF	LB_LED		;PORTB,5
	BCF	OL_LED		;PORTB,6
	BCF	CHG_LED		;PORTB,7
	bcf	trickle 
	RETURN

MAIN_ON_CHECK_STD_BY:
	CALL	AC_MAIN_READ
	BTFSC	UPS
	GOTO	INV_MAIN_CHANGEOVER_STD_BY
	GOTO	UPS_MAIN_CHANGEOVER_STD_BY
	

INV_MAIN_CHANGEOVER_STD_BY:
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'46'		;>140V AC MAIN
	BTFSS	STATUS,C
	GOTO	MAIN_ON		;yes volt is >140v
	GOTO	PORT_CHECK	;AS INV IS off
	
UPS_MAIN_CHANGEOVER_STD_BY:
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'71';d'67'		;>190V AC MAIN
	BTFSS	STATUS,C
	GOTO	MAIN_ON
	GOTO	PORT_CHECK	;AS INV IS off

MAIN_ON_CHECK_INV:
	call	delay_loop		;put main on dealy
	CALL	AC_MAIN_READ
	BTFSC	UPS
	GOTO	INV_MAIN_CHANGEOVER_INV
	GOTO	UPS_MAIN_CHANGEOVER_INV
	

INV_MAIN_CHANGEOVER_INV:
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'46'		;>140V AC MAIN
	BTFSS	STATUS,C
	GOTO	MAIN_ON		;yes volt is >140v
	GOTO	LP_3		;as inverter is ON so check the inv switch port

UPS_MAIN_CHANGEOVER_INV:
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'71';d'67'		;190V AC MAIN
	BTFSS	STATUS,C
	GOTO	MAIN_ON		;>190v
	GOTO	LP_3		;<190v
	

AC_MAIN_READ:			;checking AC Main voltage
	CLRF	R_42
	MOVLW	0XFF		
	MOVWF	R_42
LP_53	DECFSZ	R_42,1
	GOTO	LP_53
	MOVLW	b'10000001'	;SELECTED RA0,PIN2
	MOVWF	ADCON0
	MOVLW	0X1A
	MOVWF	R_42
LP_54	DECFSZ	R_42,1
	GOTO	LP_54
	BSF	ADCON0,GO
LP_55	BTFSC	ADCON0,GO
	GOTO	LP_55
	MOVF	ADRES,W
	CLRF	AC_MAIN
	MOVWF	AC_MAIN
	return




MAIN_FAIL_CHECK:
	CALL	AC_MAIN_READ
	BTFSC	UPS
	GOTO	MAIN_INV_CHANGEOVER
	GOTO	MAIN_UPS_CHANGEOVER
	
MAIN_INV_CHANGEOVER:
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'27'	;<90V 
	BTFSS	STATUS,C
	GOTO	MAIN_FAIL_CHECK	;>90V
	BCF	MAIN_LED
	BTFSC	INV_SW		;<90V
	goto	port_check		;inv sw is off
	goto	inverter_on_2		;inv sw is on


MAIN_UPS_CHANGEOVER:
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'55'	;<180V ?????????????????????
	BTFSS	STATUS,C
	GOTO	MAIN_FAIL_CHECK	;>180V
	BCF	MAIN_LED
	BTFSC	INV_SW		;<180V
	goto	port_check		;inv sw is off
	goto	inverter_on_2		;inv sw is on

delay_loop:
	MOVLW	0X64
	MOVWF	R_74
	MOVLW	0X64		;0X3C/0X10
	MOVWF	R_75
LP_37	MOVLW	0XC8		;0X64
	MOVWF	R_73
LP_38	DECFSZ	R_73,F
	GOTO	LP_38
	BTFSC	INV_SW		;PORTB,2
	GOTO	INVERTER_OFF
	DECFSZ	R_74,F
	GOTO	LP_37
	DECFSZ	R_75,F
	GOTO	LP_37
	return

BATT_READ:
	CLRF	R_42
	MOVLW	0XFF		;SENSING BATT VOLT FOR L.B
	MOVWF	R_42
LP_39	DECFSZ	R_42,1
	GOTO	LP_39
	MOVLW	b'10010001'	;SELECTED RA2,PIN4
	MOVWF	ADCON0
	MOVLW	0X1A
	MOVWF	R_42
LP_40	DECFSZ	R_42,1
	GOTO	LP_40
	BSF	ADCON0,GO
LP_41	BTFSC	ADCON0,GO
	GOTO	LP_41
	MOVF	ADRES,W	
	RETURN

OVER_LOAD_READ:
	CLRF	R_42
	MOVLW	0X13		;SENSING OVERLOAD
	MOVWF	R_42
LP_31	DECFSZ	R_42,1
	GOTO	LP_31
	MOVLW	b'10100001'	;SELECTED RA5,PIN7
	MOVWF	ADCON0
	CLRF	R_42
	MOVLW	0X1A
	MOVWF	R_42
LP_32	DECFSZ	R_42,1
	GOTO	LP_32
	BSF	ADCON0,GO
LP_33	BTFSC	ADCON0,GO
	GOTO	LP_33
	MOVF	ADRES,W	
	RETURN

LO_BATT_TRIP:
	CALL	BATT_READ
	MOVWF	BATT_VOLT
	MOVF	BATT_VOLT,W
	BCF	STATUS,C
	SUBLW	d'128'			;2.5V at pin
	BTFSS	STATUS,C
	GOTO	OVER_LOAD_CHECK		;> Batt-volt

	BSF	LB_LED
	BCF	FAN
	CALL	INV_TRIP
	CALL	TRIP_BUZZER_BEEP
	GOTO	LP_333

OVER_LOAD_TRIP:
	CALL	OVER_LOAD_READ
	MOVF	ADRES,W	
	MOVWF	OV_LOAD
	MOVF	OV_LOAD,W
	BCF	STATUS,C
	SUBLW	d'128'		;VOLT SELECTED 2.5V
	BTFSC	STATUS,C
	GOTO	LP_333		;<2.5V

	BSF	OL_LED
	BCF	FAN
	BTFSC	OL_TRIP,1
	GOTO	OL_RESET
	BSF	OL_TRIP,1
	MOVLW	0X04		;NO OF AUTO RESET
	MOVWF	R_29
OL_RESET:
	CALL	INV_TRIP
	CALL	TRIP_BUZZER_BEEP
	DECFSZ	R_29,1
	GOTO	INVERTER_ON_3
	BSF	OL_LED
	CLRF	OL_TRIP
	CLRF	R_29
	GOTO	LP_333	

TRIP_BUZZER_BEEP:
	movlw	0X09		;NO OF GOLI BUZZER BEEP
	movwf	r555
;*********GOLI BUZZER BEEP ROUTINE**************

GOLI_BUZZER:
	movlw	0XFF
	movwf	r444
	MOVLW	0XFF
	MOVWF	R333
	MOVLW	0X10
	MOVWF	R222
	BSF	BUZZER

LP_0:	DECFSZ	R444,1
	GOTO	LP_0
	BTFSC	INV_SW
	GOTO	INVERTER_OFF
	MOVLW	0XFF
	MOVWF	R444
	DECFSZ	R333,1
	GOTO	LP_0
	movlw	0XFF
	movwf	r444
	MOVLW	0XFF
	MOVWF	R333
	DECFSZ	R222,1
	GOTO	LP_0

	BCF	BUZZER
	MOVLW	0XFF
	MOVWF	R444
	MOVLW	0XFF
	MOVWF	R333
	MOVLW	0X10
	MOVWF	R222
LP_110	DECFSZ	R444,1
	GOTO	LP_110
	BTFSC	INV_SW
	GOTO	INVERTER_OFF
	MOVLW	0XFF
	MOVWF	R444
	DECFSZ	R333,1
	GOTO	LP_110
	movlw	0XFF
	movwf	r444
	MOVLW	0XFF
	MOVWF	R333
	DECFSZ	R222,1
	GOTO	LP_110	

	DECFSZ	R555,1
	GOTO	GOLI_BUZZER
	BCF	BUZZER
	RETURN
	
MAIN_ON:
	CALL	INV_TRIP
	BCF	RELAY
	BCF	INV_LED	
	BSF	MAIN_LED
	BCF	LB_LED		;PORTB,5
	BCF	OL_LED		;PORTB,6
	;GOTO	MAIN_FAIL_CHECK

CHARGING:
	BSF	FAN		;PORTC,6 FAN ON
	BSF	CHG,1		;set chg bit to ensure charging is ON
	BSF	CHG_ON,1	;make chg.on bit high
	BSF	CHG_LED		;PORTB,7 chg-led on
	MOVLW	d'01'
	MOVWF	PW
	
	BCF	VOLT,1
	BSF	STATUS,RP0
	MOVLW	d'166'		;6kHz CHARGING PWM
	MOVWF	PR2
	BCF	STATUS,RP0
	;MOVLW	d'40'		;d'85' 50% DUTY/d'40' 24% DUTY
	MOVF	PW,W
	MOVWF	CCPR1L
	BCF	CCP1CON,4
	BCF	CCP1CON,5
	BCF	CCP1CON,0
	BCF	CCP1CON,1
	BSF	CCP1CON,2
	BSF	CCP1CON,3

	MOVLW	b'00000101'
	MOVWF	T2CON
	BSF	PORTC,1		;CH-1
	BSF	PORTC,3		;CH-2

	MOVLW	d'255'
	MOVWF	COUNT_1
	MOVLW	d'03'
	MOVWF	COUNT_2
	BSF	CHG_STAGE,1

	MOVLW	0XFF		;0X64 FOR DELAY CHARGING
	MOVWF	CHG_DELAY

	movlw	0X80		;Rxx PW DELAY VALUE
	movwf	Rxxx
	

CHARGING_SET:
	BTFSS	CHG,1
	goto	trickle_chg	;??????? trickle
	;GOTO	CHG_RESTORE	
	BTFSS	CHG_LED			;PORTB,7
	GOTO	LED_OFF
LP_1F	DECFSZ	COUNT_1,1
	GOTO	PUTU	;GOTO	LP_1F
	MOVLW	d'255'
	MOVWF	COUNT_1
	DECFSZ	COUNT_2,1

	GOTO	PUTU
	BCF	CHG_LED			;PORTB,7
	MOVLW	d'255'
	MOVWF	COUNT_1
	MOVLW	d'03'
	MOVWF	COUNT_2

	GOTO	PUTU

LED_OFF:
	DECFSZ	COUNT_1,1
	GOTO	PUTU		;GOTO	LED_OFF	
	MOVLW	d'255'
	MOVWF	COUNT_1
	DECFSZ	COUNT_2,1

	GOTO	PUTU
	BSF	CHG_LED		;PORTB,7	
	MOVLW	d'255'
	MOVWF	COUNT_1
	MOVLW	d'03'
	MOVWF	COUNT_2

	GOTO	PUTU		;CHECK THE CHG STAGE

CHG_I_READ:
	MOVLW	b'10011001'
	MOVWF	ADCON0		;FOSC/8,A-D is ON,RA-3,Channel-3 selected	
	CLRF	ADRES
	MOVLW	0X1A
	MOVWF	R_42
LP_1DA	DECFSZ	R_42,1
	GOTO	LP_1DA
	BSF	ADCON0,GO
LP_1EA	BTFSC	ADCON0,GO
	GOTO	LP_1EA
	MOVF	ADRES,W
	RETURN

CHARGING_SET_3:			;1st - STEP / DELAY START
	CALL	CHG_I_READ
	MOVWF	CHG_I
	BCF	STATUS,C
	BCF	STATUS,Z
	BCF	STATUS,DC
	MOVF	CHG_I,W
	SUBLW	d'51'		;d'102'			;MAX CHARGING VALUE
	BTFSC	STATUS,C
	
	GOTO	INC_PW_1
	BCF	CHG_STAGE,1	
	GOTO	CHARGING_SET_2

PUTU:	BTFSC	CHG_STAGE,1	;BIT SET WHEN DELAY CHG
	GOTO	CHARGING_SET_3
	GOTO	CHARGING_SET_2

INC_PW_1:
	DECFSZ	CHG_DELAY,1
	GOTO	MAIN_FAILURE_CHECK
	MOVLW	0XFF			;0X64 DELAY CHG TIME
	MOVWF	CHG_DELAY	
	SELFCHECK	PW,d'100'	;MAX ALLOWABLE PW 95% d'140'
	GOTO	CHARGING_SET_2
	INCF	PW,1
	MOVF	PW,W
	MOVWF	CCPR1L
	GOTO	MAIN_FAILURE_CHECK


CHARGING_SET_2:
	;BTFSC	PW_BIT,1
	;GOTO	GULTI
	;BSF	PW_BIT,1
	;MOVLW	0X80
	;MOVWF	PW_TIMER
GULTI	;DECFSZ	PW_TIMER,1
	;GOTO	BATT_CHG_STATUS
	;BCF	PW_BIT,1
	CALL	CHG_I_READ
	MOVWF	CHG_I
	BCF	STATUS,C
	BCF	STATUS,Z
	BCF	STATUS,DC
	MOVF	CHG_I,W
	SUBLW	d'51'		;d'102'	;MAX CHARGING CURRENT VALUE
	BTFSC	STATUS,C
	GOTO	INC_PW
	GOTO	DEC_PW


INC_PW:	
	SELFCHECK pw,d'100'	;original PW,d'110'	;MAX ALLOWABLE PW 95% d'140'
	GOTO	BATT_CHG_STATUS
		;call	delay1u6

	INCF	PW,1
	MOVF	PW,W
	MOVWF	CCPR1L
	;CALL	DELAY40
	GOTO	BATT_CHG_STATUS

DEC_PW:	
	SELFCHECK pw,d'40'	;original value PW,d'80'
	GOTO	BATT_CHG_STATUS
		;call	delay1u6

	DECF	PW,1
	MOVF	PW,W
	MOVWF	CCPR1L
	;CALL	DELAY40
	GOTO	BATT_CHG_STATUS

BATT_CHG_STATUS:
	CALL	BATT_READ
	MOVWF	BATT_VOLT
	MOVF	BATT_VOLT,W
	BCF	STATUS,C
	
	SUBLW	d'178';d'174' 
	BTFSS	STATUS,C	
	;GOTO	CHG_OFF		;>13.5V / 14V
	goto	trickle_chg	;????? trickle
				
MAIN_FAILURE_CHECK:		;<13.5V
	CLRF	R_42
	MOVLW	0XFF		;SENSING MAIN_VOLT
	MOVWF	R_42
LP_46	DECFSZ	R_42,1
	GOTO	LP_46
	MOVLW	b'10000001'	;SELECTED RA0,PIN2
	MOVWF	ADCON0
	MOVLW	0X1A
	MOVWF	R_42
LP_47	DECFSZ	R_42,1
	GOTO	LP_47
	BSF	ADCON0,GO
LP_48	BTFSC	ADCON0,GO
	GOTO	LP_48
	MOVF	ADRES,W
	CLRF	AC_MAIN
	MOVWF	AC_MAIN

	BTFSC	UPS		;PORTC,4
	GOTO	H_UPS_MODE
	GOTO	UPS_MODE

UPS_MODE:
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'53'	;d'76'			;175V / 1.5V at pin2
	BTFSS	STATUS,C
	GOTO	CHARGING_SET
	GOTO	INV_START		;<175V

H_UPS_MODE:			;INVERTER MODE
	MOVF	AC_MAIN,W
	BCF	STATUS,C
	SUBLW	d'27'	;d'49'			;120V / 1.24V at pin2
	BTFSS	STATUS,C	
	GOTO	CHARGING_SET		;>120V
	GOTO	INV_START		;<120V



INV_START:
	CLRF	CHG
	CLRF	CHG_STAGE
	CLRF	CCPR1L
	CLRF	CCP1CON
	CLRF	T2CON
	BCF	PORTC,1
	BCF	PORTC,2
	BCF	PORTC,3
	BCF	CHG_LED
	BCF	MAIN_LED
	BTFSC	INV_SW		;<90V
	goto	port_check		;inv sw is off
	goto	inverter_on_2		;inv sw is on



CHG_OFF:
	bsf	trickle
	BCF	CHG,1
	BSF	CHG_LED			;PORTB,7 CHG LED ON
	BCF	FAN			;PORTC,6 FAN OFF
	CLRF	CCPR1L
	CLRF	CCP1CON
	CLRF	T2CON
	BCF	PORTC,1
	BCF	PORTC,2
	BCF	PORTC,3
	GOTO	MAIN_FAILURE_CHECK



CHG_RESTORE:
	CALL	BATT_READ	
	MOVWF	BATT_VOLT
	MOVF	BATT_VOLT,W
	BCF	STATUS,C
	SUBLW	d'160'		;VOLT SELECTED 12.5V
	BTFSS	STATUS,C	
	GOTO	MAIN_FAILURE_CHECK	;>12.5V CLOSED FOR TRICKLE	
	GOTO	CHARGING		;CLOSED WHEN CHG-OFF


TRICKLE_CHG:
	BCF	CHG,1
	BSF	CHG_LED			;PORTB,7 CHG LED ON
	BCF	FAN			;PORTC,6 FAN OFF
	movlw	0X80
	movwf	Rxxx
read_amp:
	CALL	CHG_I_READ
	MOVWF	CHG_I
	BCF	STATUS,C
	BCF	STATUS,Z
	BCF	STATUS,DC
	MOVF	CHG_I,W
	SUBLW	d'51'		;MAX CHARGING CURRENT VALUE	
	BTFSS	STATUS,C
	GOTO	DEC_PW_2	;>greater current

read_volt:
	CALL	BATT_READ
	MOVWF	BATT_VOLT
	MOVF	BATT_VOLT,W
	BCF	STATUS,C
	SUBLW	d'176'		;VOLT SELECTED 13.5V(initially d'172')
	BTFSS	STATUS,C
	GOTO	DEC_TRICKLE_DUTY	;>13.5V / 14V

	CALL	BATT_READ
	MOVWF	BATT_VOLT
	MOVF	BATT_VOLT,W
	BCF	STATUS,C
	SUBLW	d'176'		;VOLT SELECTED 13.5V
	BTFSC	STATUS,C
	GOTO	INC_TRICKLE_DUTY	;<13.5V
	GOTO	MAIN_FAILURE_CHECK

DEC_PW_2:	
	SELFCHECK PW,d'01'	;d'40'	
	GOTO	READ_VOLT
	DECF	PW,1
	MOVF	PW,W
	MOVWF	CCPR1L
	GOTO	READ_VOLT

INC_TRICKLE_DUTY:
	SELFCHECK PW,d'100'	;d'100'
	GOTO	MAIN_FAILURE_CHECK
	incf	pw,1
	movf	pw,w
	movwf	ccpr1l
	;call	delay40
	goto	main_failure_check

DEC_TRICKLE_DUTY:
	SELFCHECK PW,d'10'
	GOTO	MAIN_FAILURE_CHECK
	decf	pw,1
	movf	pw,w
	movwf	ccpr1l
	;call	delay40
	goto	main_failure_check


LABEL_0028:
		CALL	LABEL_0052
		;BSF	PORTC
		GOTO	LABEL_0053

LABEL_0011:
		CALL	LABEL_0052
		GOTO	LABEL_0053

Label_0053  BTFSC   BUZZER		;portC,5 buzzer out
            GOTO    Label_0054
            BSF     BUZZER		;portC,5 buzzer ON
            GOTO    Label_0055

Label_0054  BCF     BUZZER		;portC,5
Label_0055  DECFSZ  0x4E ,f
            GOTO    Label_0056
            BCF     BUZZER		;portC,5
Label_0057  GOTO    Label_0057

Label_0056  MOVLW   0xFA
            MOVWF   r_4B
            MOVLW   0xFA
            MOVWF   r_4C
            MOVLW   0x40
            BTFSC   r_22 ,3
            MOVLW   0x05
            MOVWF   r_4D
loop10      DECFSZ  r_4B ,f
            GOTO    loop10
            GOTO    Label_0053



Label_0052  BCF     INTCON ,GIE
            BCF     STATUS ,RP0
            CLRF    ccpr1l
	    CLRF	CCP1CON
            CLRF    portC
            CLRF    PORTB
            CLRF    r_22
            RETURN

;*********************								
;delay routines here *								
;*********************							
DELAY40								
	MOVLW 0XFF								
	MOVWF R_31								
DLOOP1:								
	DECFSZ R_31,1								
	GOTO DLOOP1								
	RETURN								
;*********************								
DELAY5MSL																
	MOVLW 0X7D								
	MOVWF R_56								
DLOOP2:								
	CALL DELAY40								
	DECFSZ R_56,1								
	GOTO DLOOP2								
	RETURN

DELAY_1S:
	MOVLW	0X1E
	MOVWF	R_38
LP_1B	MOVLW	0XFF
	MOVWF	R_37
LP_1A	CALL	DELAY40
	DECFSZ	R_37,1
	GOTO	LP_1A
	DECFSZ	R_38,1
	GOTO	LP_1B
	RETURN	

DELAY_1A
	MOVLW	0XFF
	MOVWF	R666
KALU:	CALL	DELAY1U6
	DECFSZ	R666,1
	GOTO	KALU
	RETURN	

DELAY_2S:
	CALL	DELAY_1A
	;CALL	DELAY_1A
	;CALL	DELAY_1A
	;CALL	DELAY_1A
	RETURN

DELAY1U6
	MOVLW	0X80	;0XFF
	MOVWF	R777
HODU:	DECFSZ	R777,1
	GOTO	HODU
	RETURN	
								


;*************************************************************************

	ORG	0X700
TABLE1				;SINEWAVE VALUE_1/2 CYCLE(77-STEPS)
	MOVF 	DUTY,W
	ADDWF	PCL,1
	RETLW	0X00		;d'00'
	RETLW	0X0A		;d'10'
	RETLW	0X15		;d'21'
	RETLW	0X1F		;d'31'
	RETLW	0X29		;d'41'
	RETLW	0X34		;d'52'
	RETLW	0X3E		;d'62'
	RETLW	0X48		;d'72'
	RETLW	0X52		;d'82'
	RETLW	0X5C		;d'92'
	RETLW	0X65		;d'101'
	RETLW	0X6F		;d'111'
	RETLW	0X78		;d'120'
	RETLW	0X81		;d'129'
	RETLW	0X8A		;d'138'
	RETLW	0X92		;d'146'
	RETLW	0X9B		;d'155'
	RETLW	0XA3		;d'163'
	RETLW	0XAB		;d'171'
	RETLW	0XB2		;d'178'
	RETLW	0XBA		;d'186'
	RETLW	0XC1		;d'193'
	RETLW	0XC7		;d'199'
	RETLW	0XCE		;d'206'
	RETLW	0XD4		;d'212'
	RETLW	0XD9		;d'217'
	RETLW	0XDF		;d'223'
	RETLW	0XE3		;d'227'
	RETLW	0XE8		;d'232'
	RETLW	0XEC		;d'236'
	RETLW	0XF0		;d'240'
	RETLW	0XF3		;d'243'
	RETLW	0XF6		;d'246'
	RETLW	0XF9		;d'249'
	RETLW	0XFB		;d'251'
	RETLW	0XFC		;d'252'
	RETLW	0XFE		;d'254'
	RETLW	0XFF		;d'255'
	RETLW	0XFF		;d'255'
	RETLW	0XFF		;d'255'
	RETLW	0XFF		;d'255'
	RETLW	0XFE		;d'254'
	RETLW	0XFC		;d'252'
	RETLW	0XFB		;d'251'
	RETLW	0XF9		;d'249'
	RETLW	0XF6		;d'246'
	RETLW	0XF3		;d'243'
	RETLW	0XF0		;d'240'
	RETLW	0XEC		;d'236'
	RETLW	0XE8		;d'232'
	RETLW	0XE3		;d'227'
	RETLW	0XDF		;d'223'
	RETLW	0XD9		;d'217'
	RETLW	0XD4		;d'212'
	RETLW	0XCE		;d'206'
	RETLW	0XC7		;d'199'
	RETLW	0XC1		;d'193'
	RETLW	0XBA		;d'186'
	RETLW	0XB2		;d'178'
	RETLW	0XAB		;d'171'
	RETLW	0XA3		;d'163'
	RETLW	0X9B		;d'155'
	RETLW	0X92		;d'146'
	RETLW	0X8A		;d'138'
	RETLW	0X81		;d'129'
	RETLW	0X78		;d'120'
	RETLW	0X6F		;d'110'
	RETLW	0X65		;d'101'
	RETLW	0X5C		;d'92'
	RETLW	0X52		;d'82'
	RETLW	0X48		;d'72'
	RETLW	0X3E		;d'62'
	RETLW	0X34		;d'52'	
	RETLW	0X29		;d'41'
	RETLW	0X1F		;d'31'
	RETLW	0X15		;d'21'
	RETLW	0X0A		;d'10'
	RETLW	0X00		;d'00'

            END



